#include "StringConvert.hpp"
#include "EditData.hpp"

class Extension
{
public:
	LPRDATA rdPtr;
	LPRH	rhPtr;
	Edif::Runtime Runtime;
	static const int MinimumBuild = 254;
	static const int Version = 1;
	static const int OEFLAGS = OEFLAG_VALUES|OEFLAG_RUNBEFOREFADEIN|OEFLAG_NEVERKILL;
	static const int OEPREFS = 0;
	static const int WindowProcPriority = 100;

	Extension(LPRDATA rdPtr, LPEDATA edPtr, fpcob cobPtr);
	~Extension();

	String s;
	String ErrorMessage;

	Enumeration(Trigger
	,
		Error = 0,		//OnError
	);

	//Actions
	void ActionExample(int ExampleParameter);

	//Conditions
	bool OnError(){ return true; }

	//Expressions
	const Char *GetLastError(){ return Runtime.CopyString(ErrorMessage.c_str()); }


	void GenerateError(const String &msg)
	{
		ErrorMessage = msg;
		Runtime.GenerateEvent(Trigger::Error);
	}
	bool Assert(bool exp, const String &msg)
	{
		if(!exp) GenerateError(msg);
		return exp;
	}


	void Action(int ID, LPRDATA rdPtr, long param1, long param2){}
	long Condition(int ID, LPRDATA rdPtr, long param1, long param2){ return false; }
	long Expression(int ID, LPRDATA rdPtr, long param){ return long("Unlinked Expression"); }

	short Handle();
	short Display();

	short Pause();
	short Continue();

	bool Save(HANDLE File);
	bool Load(HANDLE File);
};
